
private with Ada.Unchecked_Conversion;

private with Langkit_Support.File_Readers;
with Langkit_Support.Generic_API; use Langkit_Support.Generic_API;
private with Langkit_Support.Internal;
private with Langkit_Support.Text;
private with Langkit_Support.Types;

private with Libadalang.Implementation;

package Libadalang.Generic_API is

   Id : constant Language_Id;
   --  Unique identifier for Libadalang

private

   use Langkit_Support.File_Readers;
   use Langkit_Support.Internal;
   use Langkit_Support.Text;
   use Langkit_Support.Types;

   --  Descriptors for grammar rules

   
      
      Rule_Name_1 : aliased constant String :=
        "Parent_List";
      
      Rule_Name_2 : aliased constant String :=
        "Protected_Type_Decl";
      
      Rule_Name_3 : aliased constant String :=
        "Protected_Op";
      
      Rule_Name_4 : aliased constant String :=
        "Protected_El";
      
      Rule_Name_5 : aliased constant String :=
        "Protected_Def";
      
      Rule_Name_6 : aliased constant String :=
        "Protected_Decl";
      
      Rule_Name_7 : aliased constant String :=
        "Task_Item";
      
      Rule_Name_8 : aliased constant String :=
        "Task_Def";
      
      Rule_Name_9 : aliased constant String :=
        "Task_Type_Decl";
      
      Rule_Name_10 : aliased constant String :=
        "Subtype_Decl";
      
      Rule_Name_11 : aliased constant String :=
        "Interface_Type_Def";
      
      Rule_Name_12 : aliased constant String :=
        "Unconstrained_Index";
      
      Rule_Name_13 : aliased constant String :=
        "Array_Type_Def";
      
      Rule_Name_14 : aliased constant String :=
        "Discrete_Subtype_Definition";
      
      Rule_Name_15 : aliased constant String :=
        "Constraint_List";
      
      Rule_Name_16 : aliased constant String :=
        "Signed_Int_Type_Def";
      
      Rule_Name_17 : aliased constant String :=
        "Mod_Int_Type_Def";
      
      Rule_Name_18 : aliased constant String :=
        "Derived_Type_Def";
      
      Rule_Name_19 : aliased constant String :=
        "Discriminant_Assoc";
      
      Rule_Name_20 : aliased constant String :=
        "Discriminant_Constraint";
      
      Rule_Name_21 : aliased constant String :=
        "Index_Constraint";
      
      Rule_Name_22 : aliased constant String :=
        "Digits_Constraint";
      
      Rule_Name_23 : aliased constant String :=
        "Delta_Constraint";
      
      Rule_Name_24 : aliased constant String :=
        "Range_Constraint";
      
      Rule_Name_25 : aliased constant String :=
        "Constraint";
      
      Rule_Name_26 : aliased constant String :=
        "Discriminant_Spec";
      
      Rule_Name_27 : aliased constant String :=
        "Discr_Spec_List";
      
      Rule_Name_28 : aliased constant String :=
        "Discriminant_Part";
      
      Rule_Name_29 : aliased constant String :=
        "Enum_Literal_Decl";
      
      Rule_Name_30 : aliased constant String :=
        "Formal_Discrete_Type_Def";
      
      Rule_Name_31 : aliased constant String :=
        "Record_Def";
      
      Rule_Name_32 : aliased constant String :=
        "Range_Spec";
      
      Rule_Name_33 : aliased constant String :=
        "Real_Type_Def";
      
      Rule_Name_34 : aliased constant String :=
        "Sexpr_Or_Box";
      
      Rule_Name_35 : aliased constant String :=
        "Ordinary_Fixed_Point_Def";
      
      Rule_Name_36 : aliased constant String :=
        "Decimal_Fixed_Point_Def";
      
      Rule_Name_37 : aliased constant String :=
        "Floating_Point_Def";
      
      Rule_Name_38 : aliased constant String :=
        "Record_Type_Def";
      
      Rule_Name_39 : aliased constant String :=
        "Access_Def";
      
      Rule_Name_40 : aliased constant String :=
        "Enum_Type_Def";
      
      Rule_Name_41 : aliased constant String :=
        "Type_Def";
      
      Rule_Name_42 : aliased constant String :=
        "Variant";
      
      Rule_Name_43 : aliased constant String :=
        "Anonymous_Type_Decl";
      
      Rule_Name_44 : aliased constant String :=
        "Type_Decl";
      
      Rule_Name_45 : aliased constant String :=
        "Variant_Part";
      
      Rule_Name_46 : aliased constant String :=
        "Component_Def";
      
      Rule_Name_47 : aliased constant String :=
        "Component_Item";
      
      Rule_Name_48 : aliased constant String :=
        "Component_Decl";
      
      Rule_Name_49 : aliased constant String :=
        "Component_List";
      
      Rule_Name_50 : aliased constant String :=
        "Generic_Decl";
      
      Rule_Name_51 : aliased constant String :=
        "Generic_Formal_Part";
      
      Rule_Name_52 : aliased constant String :=
        "Generic_Formal_Decl";
      
      Rule_Name_53 : aliased constant String :=
        "Formal_Subp_Decl";
      
      Rule_Name_54 : aliased constant String :=
        "Renaming_Clause";
      
      Rule_Name_55 : aliased constant String :=
        "Generic_Renaming_Decl";
      
      Rule_Name_56 : aliased constant String :=
        "Generic_Instantiation";
      
      Rule_Name_57 : aliased constant String :=
        "Exception_Decl";
      
      Rule_Name_58 : aliased constant String :=
        "Basic_Decls";
      
      Rule_Name_59 : aliased constant String :=
        "Package_Renaming_Decl";
      
      Rule_Name_60 : aliased constant String :=
        "Package_Decl";
      
      Rule_Name_61 : aliased constant String :=
        "Basic_Decl";
      
      Rule_Name_62 : aliased constant String :=
        "Object_Decl";
      
      Rule_Name_63 : aliased constant String :=
        "Sub_Object_Decl";
      
      Rule_Name_64 : aliased constant String :=
        "Ext_Ret_Stmt_Object_Decl";
      
      Rule_Name_65 : aliased constant String :=
        "Defining_Id_List";
      
      Rule_Name_66 : aliased constant String :=
        "Number_Decl";
      
      Rule_Name_67 : aliased constant String :=
        "Contract_Case_Assoc";
      
      Rule_Name_68 : aliased constant String :=
        "Contract_Cases_Expr";
      
      Rule_Name_69 : aliased constant String :=
        "Abstract_State_Decl";
      
      Rule_Name_70 : aliased constant String :=
        "Multi_Abstract_State_Decl";
      
      Rule_Name_71 : aliased constant String :=
        "Aspect_Assoc";
      
      Rule_Name_72 : aliased constant String :=
        "Aspect_Spec";
      
      Rule_Name_73 : aliased constant String :=
        "Single_Task_Decl";
      
      Rule_Name_74 : aliased constant String :=
        "Overriding_Indicator";
      
      Rule_Name_75 : aliased constant String :=
        "Entry_Decl";
      
      Rule_Name_76 : aliased constant String :=
        "Component_Clause";
      
      Rule_Name_77 : aliased constant String :=
        "Aspect_Clause";
      
      Rule_Name_78 : aliased constant String :=
        "Param_Spec";
      
      Rule_Name_79 : aliased constant String :=
        "Param_Specs";
      
      Rule_Name_80 : aliased constant String :=
        "Subp_Spec";
      
      Rule_Name_81 : aliased constant String :=
        "Expr_Fn";
      
      Rule_Name_82 : aliased constant String :=
        "Null_Subp_Decl";
      
      Rule_Name_83 : aliased constant String :=
        "Abstract_Subp_Decl";
      
      Rule_Name_84 : aliased constant String :=
        "Subp_Renaming_Decl";
      
      Rule_Name_85 : aliased constant String :=
        "Simple_Subp_Decl";
      
      Rule_Name_86 : aliased constant String :=
        "Subp_Decl";
      
      Rule_Name_87 : aliased constant String :=
        "With_Clause";
      
      Rule_Name_88 : aliased constant String :=
        "Context_Item";
      
      Rule_Name_89 : aliased constant String :=
        "Use_Clause";
      
      Rule_Name_90 : aliased constant String :=
        "Use_Package_Clause";
      
      Rule_Name_91 : aliased constant String :=
        "Use_Type_Clause";
      
      Rule_Name_92 : aliased constant String :=
        "Subtype_Indication";
      
      Rule_Name_93 : aliased constant String :=
        "Discrete_Subtype_Indication";
      
      Rule_Name_94 : aliased constant String :=
        "Constrained_Subtype_Indication";
      
      Rule_Name_95 : aliased constant String :=
        "Type_Expr";
      
      Rule_Name_96 : aliased constant String :=
        "Anonymous_Type";
      
      Rule_Name_97 : aliased constant String :=
        "Mode";
      
      Rule_Name_98 : aliased constant String :=
        "Pragma_Argument";
      
      Rule_Name_99 : aliased constant String :=
        "Pragma";
      
      Rule_Name_100 : aliased constant String :=
        "Subunit";
      
      Rule_Name_101 : aliased constant String :=
        "Library_Unit_Body";
      
      Rule_Name_102 : aliased constant String :=
        "Library_Unit_Renaming_Decl";
      
      Rule_Name_103 : aliased constant String :=
        "Library_Item";
      
      Rule_Name_104 : aliased constant String :=
        "Compilation_Unit";
      
      Rule_Name_105 : aliased constant String :=
        "Compilation";
      
      Rule_Name_106 : aliased constant String :=
        "Decl_Part";
      
      Rule_Name_107 : aliased constant String :=
        "Entry_Body";
      
      Rule_Name_108 : aliased constant String :=
        "Protected_Body";
      
      Rule_Name_109 : aliased constant String :=
        "Protected_Body_Stub";
      
      Rule_Name_110 : aliased constant String :=
        "Task_Body";
      
      Rule_Name_111 : aliased constant String :=
        "Task_Body_Stub";
      
      Rule_Name_112 : aliased constant String :=
        "Package_Body_Stub";
      
      Rule_Name_113 : aliased constant String :=
        "Package_Body";
      
      Rule_Name_114 : aliased constant String :=
        "Terminate_Alternative";
      
      Rule_Name_115 : aliased constant String :=
        "Select_Stmt";
      
      Rule_Name_116 : aliased constant String :=
        "Accept_Stmt";
      
      Rule_Name_117 : aliased constant String :=
        "Case_Alt";
      
      Rule_Name_118 : aliased constant String :=
        "Case_Stmt";
      
      Rule_Name_119 : aliased constant String :=
        "Ext_Return_Stmt";
      
      Rule_Name_120 : aliased constant String :=
        "Iblock_Stmt";
      
      Rule_Name_121 : aliased constant String :=
        "Block_Stmt";
      
      Rule_Name_122 : aliased constant String :=
        "Iloop_Stmt";
      
      Rule_Name_123 : aliased constant String :=
        "Loop_Stmt";
      
      Rule_Name_124 : aliased constant String :=
        "Compound_Stmt";
      
      Rule_Name_125 : aliased constant String :=
        "If_Stmt";
      
      Rule_Name_126 : aliased constant String :=
        "Raise_Stmt";
      
      Rule_Name_127 : aliased constant String :=
        "Delay_Stmt";
      
      Rule_Name_128 : aliased constant String :=
        "Abort_Stmt";
      
      Rule_Name_129 : aliased constant String :=
        "Body";
      
      Rule_Name_130 : aliased constant String :=
        "Body_Stub";
      
      Rule_Name_131 : aliased constant String :=
        "Subp_Body_Stub";
      
      Rule_Name_132 : aliased constant String :=
        "Recov_Decl_Part";
      
      Rule_Name_133 : aliased constant String :=
        "Subp_Body";
      
      Rule_Name_134 : aliased constant String :=
        "Handled_Stmts";
      
      Rule_Name_135 : aliased constant String :=
        "Exception_Handler";
      
      Rule_Name_136 : aliased constant String :=
        "Stmts";
      
      Rule_Name_137 : aliased constant String :=
        "Label";
      
      Rule_Name_138 : aliased constant String :=
        "Stmt";
      
      Rule_Name_139 : aliased constant String :=
        "Call_Stmt";
      
      Rule_Name_140 : aliased constant String :=
        "Simple_Stmt";
      
      Rule_Name_141 : aliased constant String :=
        "Null_Stmt";
      
      Rule_Name_142 : aliased constant String :=
        "Assignment_Stmt";
      
      Rule_Name_143 : aliased constant String :=
        "Goto_Stmt";
      
      Rule_Name_144 : aliased constant String :=
        "Exit_Stmt";
      
      Rule_Name_145 : aliased constant String :=
        "Return_Stmt";
      
      Rule_Name_146 : aliased constant String :=
        "Requeue_Stmt";
      
      Rule_Name_147 : aliased constant String :=
        "Identifier";
      
      Rule_Name_148 : aliased constant String :=
        "Char_Literal";
      
      Rule_Name_149 : aliased constant String :=
        "String_Literal";
      
      Rule_Name_150 : aliased constant String :=
        "Defining_Id";
      
      Rule_Name_151 : aliased constant String :=
        "Dec_Literal";
      
      Rule_Name_152 : aliased constant String :=
        "Int_Literal";
      
      Rule_Name_153 : aliased constant String :=
        "Num_Literal";
      
      Rule_Name_154 : aliased constant String :=
        "Null_Literal";
      
      Rule_Name_155 : aliased constant String :=
        "Allocator";
      
      Rule_Name_156 : aliased constant String :=
        "For_Loop_Param_Spec";
      
      Rule_Name_157 : aliased constant String :=
        "Quantified_Expr";
      
      Rule_Name_158 : aliased constant String :=
        "Case_Expr";
      
      Rule_Name_159 : aliased constant String :=
        "Case_Expr_Alt";
      
      Rule_Name_160 : aliased constant String :=
        "Raise_Expr";
      
      Rule_Name_161 : aliased constant String :=
        "If_Expr";
      
      Rule_Name_162 : aliased constant String :=
        "Conditional_Expr";
      
      Rule_Name_163 : aliased constant String :=
        "Box_Expr";
      
      Rule_Name_164 : aliased constant String :=
        "Others_Designator";
      
      Rule_Name_165 : aliased constant String :=
        "Aggregate_Assoc";
      
      Rule_Name_166 : aliased constant String :=
        "Regular_Aggregate";
      
      Rule_Name_167 : aliased constant String :=
        "Bracket_Aggregate";
      
      Rule_Name_168 : aliased constant String :=
        "Aggregate";
      
      Rule_Name_169 : aliased constant String :=
        "Direct_Name";
      
      Rule_Name_170 : aliased constant String :=
        "Param_Assoc";
      
      Rule_Name_171 : aliased constant String :=
        "Call_Suffix";
      
      Rule_Name_172 : aliased constant String :=
        "Qualified_Name";
      
      Rule_Name_173 : aliased constant String :=
        "Qual_Name_Internal";
      
      Rule_Name_174 : aliased constant String :=
        "Name";
      
      Rule_Name_175 : aliased constant String :=
        "Defining_Name";
      
      Rule_Name_176 : aliased constant String :=
        "Direct_Name_Or_Target_Name";
      
      Rule_Name_177 : aliased constant String :=
        "Target_Name";
      
      Rule_Name_178 : aliased constant String :=
        "Update_Attr_Aggregate";
      
      Rule_Name_179 : aliased constant String :=
        "Update_Attr_Content";
      
      Rule_Name_180 : aliased constant String :=
        "Multidim_Array_Assoc";
      
      Rule_Name_181 : aliased constant String :=
        "Subtype_Name";
      
      Rule_Name_182 : aliased constant String :=
        "Static_Name";
      
      Rule_Name_183 : aliased constant String :=
        "Primary";
      
      Rule_Name_184 : aliased constant String :=
        "Paren_Expr";
      
      Rule_Name_185 : aliased constant String :=
        "Declare_Expr";
      
      Rule_Name_186 : aliased constant String :=
        "Factor";
      
      Rule_Name_187 : aliased constant String :=
        "Term";
      
      Rule_Name_188 : aliased constant String :=
        "Unop_Term";
      
      Rule_Name_189 : aliased constant String :=
        "Simple_Expr";
      
      Rule_Name_190 : aliased constant String :=
        "Boolean_Op";
      
      Rule_Name_191 : aliased constant String :=
        "Discrete_Range";
      
      Rule_Name_192 : aliased constant String :=
        "Choice";
      
      Rule_Name_193 : aliased constant String :=
        "Choice_List";
      
      Rule_Name_194 : aliased constant String :=
        "Rel_Op";
      
      Rule_Name_195 : aliased constant String :=
        "Membership_Choice";
      
      Rule_Name_196 : aliased constant String :=
        "Membership_Choice_List";
      
      Rule_Name_197 : aliased constant String :=
        "Relation";
      
      Rule_Name_198 : aliased constant String :=
        "Expr";
   
   Grammar_Rule_Names : aliased constant Grammar_Rule_Name_Array :=
     (1 => Rule_Name_1'Access, 2 => Rule_Name_2'Access, 3 => Rule_Name_3'Access, 4 => Rule_Name_4'Access, 5 => Rule_Name_5'Access, 6 => Rule_Name_6'Access, 7 => Rule_Name_7'Access, 8 => Rule_Name_8'Access, 9 => Rule_Name_9'Access, 10 => Rule_Name_10'Access, 11 => Rule_Name_11'Access, 12 => Rule_Name_12'Access, 13 => Rule_Name_13'Access, 14 => Rule_Name_14'Access, 15 => Rule_Name_15'Access, 16 => Rule_Name_16'Access, 17 => Rule_Name_17'Access, 18 => Rule_Name_18'Access, 19 => Rule_Name_19'Access, 20 => Rule_Name_20'Access, 21 => Rule_Name_21'Access, 22 => Rule_Name_22'Access, 23 => Rule_Name_23'Access, 24 => Rule_Name_24'Access, 25 => Rule_Name_25'Access, 26 => Rule_Name_26'Access, 27 => Rule_Name_27'Access, 28 => Rule_Name_28'Access, 29 => Rule_Name_29'Access, 30 => Rule_Name_30'Access, 31 => Rule_Name_31'Access, 32 => Rule_Name_32'Access, 33 => Rule_Name_33'Access, 34 => Rule_Name_34'Access, 35 => Rule_Name_35'Access, 36 => Rule_Name_36'Access, 37 => Rule_Name_37'Access, 38 => Rule_Name_38'Access, 39 => Rule_Name_39'Access, 40 => Rule_Name_40'Access, 41 => Rule_Name_41'Access, 42 => Rule_Name_42'Access, 43 => Rule_Name_43'Access, 44 => Rule_Name_44'Access, 45 => Rule_Name_45'Access, 46 => Rule_Name_46'Access, 47 => Rule_Name_47'Access, 48 => Rule_Name_48'Access, 49 => Rule_Name_49'Access, 50 => Rule_Name_50'Access, 51 => Rule_Name_51'Access, 52 => Rule_Name_52'Access, 53 => Rule_Name_53'Access, 54 => Rule_Name_54'Access, 55 => Rule_Name_55'Access, 56 => Rule_Name_56'Access, 57 => Rule_Name_57'Access, 58 => Rule_Name_58'Access, 59 => Rule_Name_59'Access, 60 => Rule_Name_60'Access, 61 => Rule_Name_61'Access, 62 => Rule_Name_62'Access, 63 => Rule_Name_63'Access, 64 => Rule_Name_64'Access, 65 => Rule_Name_65'Access, 66 => Rule_Name_66'Access, 67 => Rule_Name_67'Access, 68 => Rule_Name_68'Access, 69 => Rule_Name_69'Access, 70 => Rule_Name_70'Access, 71 => Rule_Name_71'Access, 72 => Rule_Name_72'Access, 73 => Rule_Name_73'Access, 74 => Rule_Name_74'Access, 75 => Rule_Name_75'Access, 76 => Rule_Name_76'Access, 77 => Rule_Name_77'Access, 78 => Rule_Name_78'Access, 79 => Rule_Name_79'Access, 80 => Rule_Name_80'Access, 81 => Rule_Name_81'Access, 82 => Rule_Name_82'Access, 83 => Rule_Name_83'Access, 84 => Rule_Name_84'Access, 85 => Rule_Name_85'Access, 86 => Rule_Name_86'Access, 87 => Rule_Name_87'Access, 88 => Rule_Name_88'Access, 89 => Rule_Name_89'Access, 90 => Rule_Name_90'Access, 91 => Rule_Name_91'Access, 92 => Rule_Name_92'Access, 93 => Rule_Name_93'Access, 94 => Rule_Name_94'Access, 95 => Rule_Name_95'Access, 96 => Rule_Name_96'Access, 97 => Rule_Name_97'Access, 98 => Rule_Name_98'Access, 99 => Rule_Name_99'Access, 100 => Rule_Name_100'Access, 101 => Rule_Name_101'Access, 102 => Rule_Name_102'Access, 103 => Rule_Name_103'Access, 104 => Rule_Name_104'Access, 105 => Rule_Name_105'Access, 106 => Rule_Name_106'Access, 107 => Rule_Name_107'Access, 108 => Rule_Name_108'Access, 109 => Rule_Name_109'Access, 110 => Rule_Name_110'Access, 111 => Rule_Name_111'Access, 112 => Rule_Name_112'Access, 113 => Rule_Name_113'Access, 114 => Rule_Name_114'Access, 115 => Rule_Name_115'Access, 116 => Rule_Name_116'Access, 117 => Rule_Name_117'Access, 118 => Rule_Name_118'Access, 119 => Rule_Name_119'Access, 120 => Rule_Name_120'Access, 121 => Rule_Name_121'Access, 122 => Rule_Name_122'Access, 123 => Rule_Name_123'Access, 124 => Rule_Name_124'Access, 125 => Rule_Name_125'Access, 126 => Rule_Name_126'Access, 127 => Rule_Name_127'Access, 128 => Rule_Name_128'Access, 129 => Rule_Name_129'Access, 130 => Rule_Name_130'Access, 131 => Rule_Name_131'Access, 132 => Rule_Name_132'Access, 133 => Rule_Name_133'Access, 134 => Rule_Name_134'Access, 135 => Rule_Name_135'Access, 136 => Rule_Name_136'Access, 137 => Rule_Name_137'Access, 138 => Rule_Name_138'Access, 139 => Rule_Name_139'Access, 140 => Rule_Name_140'Access, 141 => Rule_Name_141'Access, 142 => Rule_Name_142'Access, 143 => Rule_Name_143'Access, 144 => Rule_Name_144'Access, 145 => Rule_Name_145'Access, 146 => Rule_Name_146'Access, 147 => Rule_Name_147'Access, 148 => Rule_Name_148'Access, 149 => Rule_Name_149'Access, 150 => Rule_Name_150'Access, 151 => Rule_Name_151'Access, 152 => Rule_Name_152'Access, 153 => Rule_Name_153'Access, 154 => Rule_Name_154'Access, 155 => Rule_Name_155'Access, 156 => Rule_Name_156'Access, 157 => Rule_Name_157'Access, 158 => Rule_Name_158'Access, 159 => Rule_Name_159'Access, 160 => Rule_Name_160'Access, 161 => Rule_Name_161'Access, 162 => Rule_Name_162'Access, 163 => Rule_Name_163'Access, 164 => Rule_Name_164'Access, 165 => Rule_Name_165'Access, 166 => Rule_Name_166'Access, 167 => Rule_Name_167'Access, 168 => Rule_Name_168'Access, 169 => Rule_Name_169'Access, 170 => Rule_Name_170'Access, 171 => Rule_Name_171'Access, 172 => Rule_Name_172'Access, 173 => Rule_Name_173'Access, 174 => Rule_Name_174'Access, 175 => Rule_Name_175'Access, 176 => Rule_Name_176'Access, 177 => Rule_Name_177'Access, 178 => Rule_Name_178'Access, 179 => Rule_Name_179'Access, 180 => Rule_Name_180'Access, 181 => Rule_Name_181'Access, 182 => Rule_Name_182'Access, 183 => Rule_Name_183'Access, 184 => Rule_Name_184'Access, 185 => Rule_Name_185'Access, 186 => Rule_Name_186'Access, 187 => Rule_Name_187'Access, 188 => Rule_Name_188'Access, 189 => Rule_Name_189'Access, 190 => Rule_Name_190'Access, 191 => Rule_Name_191'Access, 192 => Rule_Name_192'Access, 193 => Rule_Name_193'Access, 194 => Rule_Name_194'Access, 195 => Rule_Name_195'Access, 196 => Rule_Name_196'Access, 197 => Rule_Name_197'Access, 198 => Rule_Name_198'Access);

   --  Implementations for generic operations on analysis types

   function Create_Context
     (Charset     : String;
      File_Reader : File_Reader_Reference;
      With_Trivia : Boolean;
      Tab_Stop    : Natural) return Internal_Context;

   procedure Context_Inc_Ref (Context : Internal_Context);
   procedure Context_Dec_Ref (Context : in out Internal_Context);
   function Context_Version (Context : Internal_Context) return Version_Number;
   function Context_Has_Unit
     (Context : Internal_Context; Unit_Filename : String) return Boolean;
   function Context_Get_From_File
     (Context           : Internal_Context;
      Filename, Charset : String;
      Reparse           : Boolean;
      Rule              : Grammar_Rule_Index) return Internal_Unit;

   function Unit_Version (Unit : Internal_Unit) return Version_Number;
   function Unit_Root (Unit : Internal_Unit) return Internal_Node;
   function Unit_Get_Line
     (Unit : Internal_Unit; Line_Number : Positive) return Text_Type;

   type Internal_Node_Metadata_Type is record
      Ref_Count : Natural;
      Internal  : Implementation.Internal_Metadata;
   end record;
   type Internal_Node_Metadata_Access is
      access all Internal_Node_Metadata_Type;

   function "+" is new Ada.Unchecked_Conversion
     (Internal_Node_Metadata, Internal_Node_Metadata_Access);
   function "+" is new Ada.Unchecked_Conversion
     (Internal_Node_Metadata_Access, Internal_Node_Metadata);

   procedure Node_Metadata_Inc_Ref (Metadata : Internal_Node_Metadata);
   procedure Node_Metadata_Dec_Ref (Metadata : in out Internal_Node_Metadata);

   function Node_Parent (Node : Internal_Node) return Internal_Node;
   function Node_Children_Count (Node : Internal_Node) return Natural;
   procedure Node_Get_Child
     (Node            : Internal_Node;
      Index           : Positive;
      Index_In_Bounds : out Boolean;
      Result          : out Internal_Node);
   function Node_Fetch_Sibling
     (Node : Internal_Node; Offset : Integer) return Internal_Node;

   function Entity_Image (Entity : Internal_Entity) return String;

   --  Language descriptor table for Libadalang

   Language_Name : aliased constant String :=
     "Ada";

   Desc : aliased constant Language_Descriptor :=
     (Language_Name => Language_Name'Access,

      Default_Grammar_Rule => 105,
      Grammar_Rule_Names   => Grammar_Rule_Names'Access,

      Create_Context        => Create_Context'Access,
      Context_Inc_Ref       => Context_Inc_Ref'Access,
      Context_Dec_Ref       => Context_Dec_Ref'Access,
      Context_Version       => Context_Version'Access,
      Context_Has_Unit      => Context_Has_Unit'Access,
      Context_Get_From_File => Context_Get_From_File'Access,

      Unit_Version  => Unit_Version'Access,
      Unit_Root     => Unit_Root'Access,
      Unit_Get_Line => Unit_Get_Line'Access,

      Node_Metadata_Inc_Ref => Node_Metadata_Inc_Ref'Access,
      Node_Metadata_Dec_Ref => Node_Metadata_Dec_Ref'Access,

      Node_Parent         => Node_Parent'Access,
      Node_Children_Count => Node_Children_Count'Access,
      Node_Get_Child      => Node_Get_Child'Access,
      Node_Fetch_Sibling  => Node_Fetch_Sibling'Access,

      Entity_Image => Entity_Image'Access);

   function "+" is new Ada.Unchecked_Conversion
     (Language_Descriptor_Access, Language_Id);
   Id : constant Language_Id := +Desc'Access;

end Libadalang.Generic_API;
